#include "ObjectX.h"

ObjectX::ObjectX(IDirect3DDevice9* Device)
{
	xfile = new XFile(Device);
	yRot = 0.0f;
	xTran = 0.0f;
	yTran = 0.0f;
	zTran = 0.0f;
}

void ObjectX::setYRot(float y)
{
	yRot = y;
}

void ObjectX::setTran(float x, float y, float z)
{
	xTran = x;
	yTran = y;
	zTran = z;	
}

void ObjectX::setBSphere()
{
	BYTE* v = 0;
	D3DXVECTOR3 tmp(xTran,yTran,zTran);

	xfile->Mesh->LockVertexBuffer(0, (void**)&v);	

	D3DXComputeBoundingSphere(
		(D3DXVECTOR3*)v,
		xfile->Mesh->GetNumVertices(),
		D3DXGetFVFVertexSize(xfile->Mesh->GetFVF()),
		&BSphere._center,
		&BSphere._radius);

	xfile->Mesh->UnlockVertexBuffer();

	BSphere._center += tmp;
}

void ObjectX::display()
{
	D3DXMATRIX myRot;
	D3DXMATRIX mTran;
	D3DXMATRIX mWorld;

	D3DXMatrixRotationY(&myRot, yRot);
	D3DXMatrixTranslation(&mTran, xTran,yTran,zTran);
	mWorld = myRot * mTran;

	xfile->display(&mWorld);
}

void ObjectX::setFile(char *fileName)
{
	xfile->loadMesh(fileName);
}